VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsXTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Modified version of high performance timer from Doberenz/Kowalski (see also Hirfs)

Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As LARGE_INTEGER) As Long

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private TimStart As LARGE_INTEGER
Private TimEnd As LARGE_INTEGER
Private TimFreq As LARGE_INTEGER
Private TimCorr As Double
Private TimFreqHz As Double
Private CPU_Freq As Long
Private Sub Class_Initialize()
    Call QueryPerformanceFrequency(TimFreq)
    TimFreqHz = Lrg_to_Dbl(TimFreq)
    CPU_Freq = 300 ' put your own frequecy here
End Sub

Public Sub Calibrate()
    
    'used to correct the time of turning the timer on/off

    Call QueryPerformanceCounter(TimStart)
    Call QueryPerformanceCounter(TimEnd)
    
    TimCorr = 1 * (Lrg_to_Dbl(TimEnd) - Lrg_to_Dbl(TimStart)) / TimFreqHz   ' Millisekunden.
    
End Sub

Function CPU_ticks(ByVal freq As Double, ByVal nOps As Double, ByVal t As Double) As Long
    '
    ' Frequ = cpu frequency in Mhz
    '
    On Error GoTo err1
    If nOps <= 0 Then
        nOps = 1
    End If
    Dim res As Double
    Dim tSec As Double
    
    tSec = nOps / t
    'tau = t / ops
    res = (freq * 1000000#) / tSec
    CPU_ticks = CLng(res)
    
exi:
    
    Exit Function
' ******** normal end of function ******************

err1:
    
    Select Case Err

    Case 9999

    Case Else

        MsgBox Err & ": " + Error$, 16, "Cpu_ticks"
        Resume err2

    End Select

err2:
    
End Function

Public Sub StartTimer()
    Call QueryPerformanceCounter(TimStart)
End Sub

Public Sub StopTimer()
    Call QueryPerformanceCounter(TimEnd)
End Sub

Public Property Get TimeElapsed() As Double

    ' time is returned in milliseconds
    TimeElapsed = (Lrg_to_Dbl(TimEnd) - Lrg_to_Dbl(TimStart)) / TimFreqHz - TimCorr
    If TimeElapsed < 0 Then
        TimeElapsed = 0
    End If
    
End Property

Public Property Get nCPU_ticks(ByVal nOps As Double) As Long
    
    ' additional property to calcultate numder of CPU ticks to
    ' get a CPU independent result
    
    Dim timeElaps
    timeElaps = (Lrg_to_Dbl(TimEnd) - Lrg_to_Dbl(TimStart)) / TimFreqHz - TimCorr
    If timeElaps < 0 Then
        timeElaps = 0
    End If
    nCPU_ticks = CPU_ticks(CPU_Freq, nOps, timeElaps)
    
End Property

Private Function Old_Lrg_to_Dbl(liX As LARGE_INTEGER) As Double
    ' This produces an error with negative values of lix.lowpart
    Old_Lrg_to_Dbl = liX.lowpart + liX.highpart * 4294967296#
End Function

Private Function Lrg_to_Dbl(x As LARGE_INTEGER) As Double
    
    If x.highpart = 0 Then
        If x.lowpart > 0 Then
            Lrg_to_Dbl = x.lowpart
        Else
            Lrg_to_Dbl = 4294967296# + x.lowpart + 1
        End If
    Else
        Dim l As Double
        Dim h As Double
        l = x.lowpart
        h = x.highpart
        If l < 0 Then
            l = 4294967296# + l + 1
        End If
        If h < 0 Then
            h = 4294967296# + h + 1
        End If
        Lrg_to_Dbl = l + h * 4294967296#
        
    End If
    
End Function

